/******Example 1***********/
ODS _all_ close;
ods listing;

options nocenter ls=200;
run;
Proc sort data=sashelp.class
          out=Sorted_Class;
 by sex age;
run;

proc print data=Sorted_Class;
run;

Proc sql;
  select avg(height), avg(weight) 
  into :Avg_ht, :avg_wt
  from Sorted_Class 
quit;
%put Avg_ht=&Avg_ht avg_wt=&avg_wt;


Data Example1 (drop= AverageHt AverageWt ) /debug ;
   Retain Retained_Obs_No  Ret_N_Zro_obs_no;
   array Vital(2) AverageHt AverageWt (&Avg_ht, &avg_wt);
   AboveSet="Un"||"usual";
  set sorted_Class(drop=age rename=(Name=StName)) end=eof NOBS=OBS;
  by sex;
  If mod(_n_,2)=0 and sex="F" then LagName=lag1(StName);
    if _n_=1 then Obs_No=0; Else Obs_No=Obs_No+1;
    if _n_=1 then Ret_N_Zro_obs_no = 0; 
       Else Ret_N_Zro_obs_no=Ret_N_Zro_obs_no+1;
    Retained_Obs_No=Retained_Obs_No+1;

    Simple_Obs_No+1;
  ArrayMin=LBound(Vital);
  ArrayMax=HBound(Vital);
  ArrayDim=Dim(Vital);
  Ht_Diff=height-vital(1);
  Wt_Diff=weight-AverageWt;
  IF _N_=1 THEN CALL SymPutX("ObsCnt",obs);
  run;

proc print data=Example1;
run;
  %put **&ObsCnt**;
  
Data _null_;
   if 0 /*this is always false & NEVER executes*/ 
       then set SasHelp.Air Nobs=ObsCount;
  call SymPut('OldObsIn_Air', left(Put(ObsCount,2.0)));
  call SymPutX('ObsIn_Air', ObsCount);
run;
%put OldObsIn_Air=**&OldObsIn_Air**;/*intentional error left(Put(ObsCount,3.0))*/
%put ObsIn_Air   =**&ObsIn_Air**  ;

/******* get # of obe into a macro ************/
Data _null_;
   if 0 /*this is always false & NEVER executes*/ 
      then set SASHelp.class NObs=ObsCount;
  call SymPutX('ObsInFile', ObsCount);
run;

%put 'ObsInFile' = **&ObsInFile**;


/******Example 2***********/
data Demog;
  infile  datalines truncover firstobs=3;
  input @1 name $char5. @7 ID 1. @10 age 2. @13 weight 3.;
datalines;
         1         2  
12345678901234567890
Russ  1  23 170
Yatzi 2  28 101
Mike  3  29 240
;
run;

proc print data=Demog;
run;

Data Visits;
  infile  datalines truncover firstobs=3;
  input @1 ID 1. @5 Visit 2. @10 Systolic 3.;
datalines;
         1         2  
12345678901234567890
1   1    120
1   2    110
1   3    105
2   1    100
2   2    100
3   1    140
;
run;

proc print data=Visits;
run;

data OOps/Debug;
	merge visits(SortedBy= ID) Demog (SortedBy= ID);
	by ID;
	label age = "Age in Months";
	Age = Age*12;
run;

proc print data=oops;
run;

data OOps2;
	merge Demog (SortedBy= ID)
	      visits(SortedBy= ID);
	by ID;
	label age = "Age in Months";
	Age_mo = Age*12;
run;

proc print data=oops2;
run;


/******Example 3***********/

Data Use_where /debug;
  set sorted_Class;
  where sex="M";
run;

Data Use_if /debug;
  set sorted_Class;
  if sex="M";
run;

  /**** example 4*******/
  data Oddwhere;
   set sorted_Class;
   where age GT 13;
   where sex="F";
run;  

 proc print data=Oddwhere;
 run;

 /***** Example 4 DOW Loop **/
 DATA Stu_Grades;
  infile datalines firstobs=3 truncover;
  INPUT @1 name $char5. @7 sex $char1. @9 exam 1. @12 grade 3.;
DATALINES;
         1         2
12345678901234567890
Aruna f 1  90
Aruna f 2  93
Zihui f 3  97
Zihui f 1  95
Zihui f 2  95
;
PROC SORT DATA=Stu_Grades;
  BY name;
run;

PROC PRINT DATA=Stu_Grades; RUN;

DATA Stu_Averages / DEBUG;
  Tests_taken = 0;
  Grade_total = 0;
  DO UNTIL (LAST.name);
     SET Stu_Grades;
     BY name; 
     Tests_taken + 1;
     Grade_total + grade;
  END;
  Avg_Grade = Grade_total / Tests_taken;
run;
PROC PRINT DATA=Stu_Averages; RUN;

  /**** example 5 temp varioables do not show in the PDV *******/
data show_temp /debug;
  array alone(4) _temporary_ (11 22 33 44 );
  Noote ="This is just to show temp array variables";
  set sashelp.class;
   do i=1 to 4;
     alone(i)=i*2;
   end;
 run;




/**************************************************************/
/************ lavery global forum paper*****************************/
/**************************************************************/


*****************************************************************************; 
**  April 24 -- DSD_HOW_SGF_2007  russ@russ.lavery.com                     **; 
**  This is the section for introducing the Datasets                       **; 
**                                                                         **; 
*****************************************************************************; 
OPTIONS NOCENTER; 
proc format; 
  value born_in 1="NE" 
  				2="SE" 
				3="NW" 
				4="SW" 
				5="Intnl"; 
run; 

data humans (sortedby=name);; 
 infile datalines missover firstobs=2; 
 input @1  name $char8. @10  time_W_co @15  sex $char1. @18  job $char4.  @25  line_no; 
datalines; 
123456789012345678901234567890 
Art      1    M  Stat   1 
Brent    6    M  Stat   2 
Cathy    6    F  Stat   3 
Debbie   5    F  Stat   4 
Jen      13   F  Stat   5 
Russ     2    M  Prog   6 
Saad     3    M  Prog   7 
Tom      6    M  Stat   8 
Zim      6    M  Stat   9 
; 
run;
 
data pets (sortedby=name); 
  infile datalines missover firstobs=2; 
  input @1 name $char8. @9 repeat @15 type $char3. @20 Pet_nm  $char8.; 
datalines; 
123456789012345678901234567890 
Art     1     Dog  Catcher 
Brent   1     N 
Cathy   1     Dog  R.A. 
Debbie  1     Dog  Dusty 
Jen     1     Cat  Princess 
Jen     2     Cat  Gabbie 
Jen     3     Cat  India 
Mary    1     Dog  Rao 
Saad    1     N 
; 
run; 

*****************************************************************************; 
*0    Step return jump go quit                                             ; 
*****************************************************************************; 
*Snippet 0A  Step return jump go quit    ; 
*****************************************************************************; 
**                                                                         **; 
**  Example of a how knowledge of the PDV is essential                     **; 
**  There are no error messages, just a list of values that you must       **; 
** interpret according to your expectations                                **; 
** use the f4 key and binding to keys                                      **; 
** look at when num-h is created- before the set statement executes        **; 
**                                                                         **; 
*****************************************************************************; 
* use this code for issuing step <RET> jump go and quit; 
* This is going to take a 1 out of 2 sample from work.humans ; 
data
 sample / debug; 
   *focus on _N_, values in the PDV and num_h; 
   do obsnum=1 to num_h by 2; 
      *just another non-executable comment; 
      set humans point=obsnum nobs=num_h; 
      if _error_ then abort; 
      output; 
   end; 
   stop; 
run; 

*****************************************************************************; 
*1    Examine, list and describe                                             ; 
*****************************************************************************; 
*Snippet 1A Examine, list and describe; 
*****************************************************************************; 
**                                                                         **; 
**  Example of a how knowledge of the PDV is essential                     **; 
**  There are no error messages, just a list of values that you must       **; 
** interpret according to your expectations.                               **; 
** Use the f4 key and binding commands to keys to reduce typing.           **; 
** Look at when num-h is created- before the set statement.                **; 
** the creation of Num-h is, before the execution of any statemets, is     **; 
**  evidence that there are commands that are "for" the compiler           **;                                                  
**; 
*****************************************************************************; 
*One way to select a subset of the data - use Direct Pointer Control (point=) and a do ; 
*Use this example to practice: examine list and describe commands; 
data
 sample / debug; /*focus on _N_, values in the PDV and num_h*/ 
*just a non-executable comment; 
   do obsnum=1 to num_h by 2; 
      *another non-executable comment; 
      set humans point=obsnum nobs=num_h; 
      if _error_ then abort; 
      output; 
	  10 
   end; 
   stop; 
run
; 


*Snippet 1B Examine, list and describe; 
*****************************************************************************; 
**                                                                         **; 
**  Shows the DANGER of recoding inside a data step doeing a one2many merge**; 
**  See the first. and last. variables in a t of values that you must      **; 
**  Interpret according to your expectations                               **; 
**  Use the f4 key and binding to keys                                     **; 
**  Notice when num-h is created- before the set statement                 **; 
**                                                                         **; 
*****************************************************************************; 
* Shows the danger of recoding in a one to many merge                        ;  
* Shows the first. and last. variables                                       ; 
* Use jump to skip the calculation of time _w_co                             ; 
* there is a danger, in one to many merges, in modifying variables on the one; 
data  matching   /   debug   ; 
 merge humans(in=h) pets(in=p); 
   stop_pt=1; 
   by name; 
   time_W_co=time_W_co*12; 
   *stop_pt=1; 
run; 

proc print data=matching;; 
run
; 


*Snippet 1C Examine, list and describe; 
*****************************************************************************; 
**                                                                         **; 
**  Look at the input buffer - not just the PDV                            **; 
**  Try thse commands: list I, b W _all_                                   **; 
**  Notice that the input buffer contains Brent                            **; 
**         but the variable name only contains rent                        **; 
** Also see the list command as a tool for managing break and watch points **; 
** Issue DESCRIBE _ALL_ COMMAND -Does show formats - see variable someday  **; 
*****************************************************************************; 
** You can compare the PDV and the input bufffer  
to see what is wrong with reading the observations for Art and Brent; 
data  pets2 (sortedby=name)/debug; 
  infile datalines missover firstobs=2; 
  input @2 name $char8. @9 repeat 4.2 @15 type $char3.  @20 Pet_nm  $char8. 
                        @9 someday ; 
  format someday date9.; 
datalines; 
123456789012345678901234567890 
 Art    1     Dog  Catcher    
Brent   1     N 
Cathy   1     Dog  R.A. 
Debbie  1     Dog  Dusty 
Jen     1     Cat  Princess 
Jen     2     Cat  Gabbie 
Jen     3     Cat  India 
Mary    1     Dog  Rao 
Saad    1     N 
; 
run;

 *Snippet 1D Examine, list and describe; 
*****************************************************************************; 
**                                                                         **; 
** Issue the command Examine, SHOW DATES WITH FORMATS, FORMATS FOR NUMBER  **; 
** use the f4 key and binding to keys                                      **; 
** USE EXAMINE ON THIS                                                     **; 
**                                                                         **; 
*****************************************************************************; 
**Use this code to show effect of keep on data step statement vs set statement; 
**This effect shows up on the mergeing of left and right on line 233; 
data left; 
  infIle datalines missover firstobs=3; 
  input @1 name $char4. @8 gender 1.  @10 enroll DATE9.; 
  THIS_DATE=TODAY(); 
  ENROLLED=THIS_DATE-ENROLL; 
datalines; 
         1         2         3         4         5 
12345678901234567890123456789012345678901234567890 
Sai    1 01JAN2003 
Yung   1 05FEB2002 
Yong   1 12MAR2002 
ODD    3 22MAR2004 
Sue    2 22SEP2001 
Bob    1 18AUG1998 
RUSS   1 19JUN1997 
LIJI   1 30SEP1995 
MUSA   1 20JUL2001 
DEB    2 11MAR2002 
; 
RUN
; 
 

data  RIGHT; 
  infIle datalines truncover firstobs=3; 
  input @1  name $char4. @8 CHILDREN 1.  @10 SCHOOL $CHAR1. @15 HAS_BOY $CHAR1. @20 HAS_grl $CHAR1.; 
  THIS_DATE=TODAY(); 
datalines; 
         1         2         3         4         5 
12345678901234567890123456789012345678901234567890 
Sai    1 NO   Y    N 
Yung   2 YES  Y    Y 
Yong   1 NO   Y    N 
ODD    3 YES  Y    Y 
RUSS   0      N    N 
Sue    2 YES  N    Y 
Bob    2 NO   Y    N 
LIJI   2 NO   Y    Y 
DEB    3 YES  Y    Y 
; 
RUN; 

*SNIPPET  1D_A 
**Show a keep on the INPUT vs a KEEP on the OUTPUT data set; 
**Use Ex _all_ to see the PDV  ; 
data show_keep1(keep=F_NAME wks_enr) /debug; 
  *keep on output brings all vars into PDV; 
  *the PDV shows the variable F_name and not NAME; 
  set left (RENAME =(NAME=F_NAME)); 
  wks_enr=enrolled/7; 
run
; 
PROC PRINT data=show_keep1; 
  TITLE "we had many variables on the PDV , but few in output dataset"; 
RUN
; 
**A SNIPPET FOR INDEPENDENT EXPLORATION; 
*CODE BELOW WILL CAUSE AN ERROR -  RENAMED VARIBLE IS ON THE pdv AND CAN NOT BE KEPT ON OUTPUT; 
data show_keep2(keep=name wks_enr) /debug; 
  set left(keep=name enrolled RENAME =(NAME=F_NAME)); 
  wks_enr=enrolled/7; 
  FrstLetr=substr(name,1,1); 
  *Name was renamed on set--caracters are sent to F_name; 
run;
 
**ANOTHER SNIPPET FOR INDEPENDENT EXPLORATION; 
** The PDV is created before the data is read, so the first definition of has_a_boy sets length; 
** The order of Y and N, in the data does not matter; 
Data Problem/DEBUG; 
  set right; 
  if has_boy="N" then has_a_boy="NO";*use describe to see has_a_boy will be length 2; 
    else has_a_boy="YES"; 
run;
 
Data OK_length/DEBUG; 
  set right; 
  if has_boy="Y" then has_a_boy="YES";*use describe to see has_a_boy will be length 3; 
    else has_a_boy="NO"; 
run;

*****************************************************************************; 
*    BREAK, Delete Watch Trace                                               ; 
*****************************************************************************; 
*Snippet 2A   BREAK, Delete Watch Trace ; 
**This is a GOOD TRICK. Variables from input (datalines or text file) are NOT retained  
**   they are set to missing at the top of the data step and watch variable command will have problems; 
** Variables from a set statement ARE retained - so less useful for vars from data set; 
** Run PBLM_Pets and set a watch for repeat; 
** Then uncomment the retain on line 298 and run again; 
data Prblm_pets (sortedby=name)/debug; 
  infile datalines missover firstobs=2; 
  *retain repeat; 
   input @2 name $char5. @9 repeat 4.2 @15 type $char3.  @20 Pet_nm  $char8. 
         @9 someday ; 
  format someday date9.; 
datalines; 
123456789012345678901234567890 
 Art    1     Dog  Catcher 
 Brent  1     N 
Cathy   1     Dog  R.A. 
Debb    1     Dog  Dusty 
Jen     1     Cat  Princess 
Jen     2     Cat  Gabbie 
Jen     3     Cat  India 
Mary    1     Dog  Rao 
Saad    1     N 
; 
run; 


*Snippet 2B   BREAK, Delete Watch Trace ; 
*****************************************************************************; 
** Set break point                                                         **; 
**  Look at the input buffer - not just the PDV                            **; 
**  list I, b W _all_                                                      **; 
**  notice that the input buffer contains Brent                            **; 
**         but the variable name only contains rent                        **; 
** also see the list command as a tool for managing break and watch points **; 
** ISSUE THE DESCRIBE _ALL_ COMMAND  -Does show formats - see someday      **; 
*****************************************************************************; 
*Snippet 2A   BREAK, Delete Watch Trace ; 
*Use for debugger for a do loop; 
*Break when I = 1 and  when I = the exit condition.  Allows you to check start and end of looping; 
*You can divide the max by an integer and use in the break; 
*Put in a non-ececutable line; 
*Break with an in to break just before / after the cutpoints; 
options nocenter; 
data non_profit  keep=name gender i YearToSearch rename=(i=AgeInFile))  
  /DEBUG; 
  *Retain age_grp; 
  infile datalines missover firstobs=3; 
  length age_grp $ 5; 
  input @1 name $char8. @10 gender $char1. @13 age1   2.0  @17 Home   $char8. 
        @25 Q1_hrs 3.  @30 Q2_hrs 3.  @35 region 1.; 
  ThisYear =year(today()); 
  Firstyear=Thisyear-age1; 
  total= Q1_hrs + Q2_hrs; 

  pct_1= Q1_hrs  /total; 
  pct_2= Q1_hrs  /total; 
  *intentional mistake-  
  compare contnets of PDV with what you expected; 
  do i=0  to age1;  
    /*Output a line for every year:  
     i=age of patient in that year*/ 
     stopper="here"; 
     YearToSearch=firstyear+i; 
     if i LE 12
         then do;  
              age_grp ="Child";  
              output non_profit; 
              end;                  
     else if i GT 12 and i LT 20
         then do; 
              age_grp ="Teen";  
              output non_profit; 
              end; 
    else if i GE 21
         then do; 
              age_grp ="Adult";  
              output non_profit; 
              end;         
  end;/*End of looping example do i=0  to age1*/ 
datalines; 
         1         2         3         4 
1234567890123456789012345678901234567890 
Sue      F  10  Florida 017  022  2 
Mike     M  12  Conn    027  042  1 
Erin     F  13 Ireland  021  012  5 
Ya-Ching F  20  China   017  024  5 
Ann      F  21  Mass    022  014  1  
Jeff     M  45 Calif    078  099  4 
Yuan     F  27  Nevada  026  046  4 
Suna     F  31  India   017  011  5 
Eric     M  45  Oregon  041  023  3 
; 
run; 

proc print data=non_profit; 
run;


*****************************************************************************; 
**  SPEED TRICKS                                                           **; 
*****************************************************************************; 
*****************************************************************************; 
**                                                                         **; 
**  Most Importantly --- STORE AN ABBREVIATION IN A KEY                     **; 
**                                                                         **; 
*****************************************************************************; 
*STORE A MACRO IN A KEY  The command below is useful; 
/*  DSD STEP 1; DSD EXAMINE _ALL;  */ 
**Collect code in a file; 
%let dsn=WhoWHo; 
%MACRO series; 
  data &dsn; 
  total= %do i=6 %to 12; 
            &i %str(+) 
         %end; 
         0; 
run; 
proc print data= &dsn; 
  title "Macro lookat"; 
run; 
%MEND series; 

options mprint mfile; 
filename mprint "c:\temp\series_txt.txt"; 
%series ;
 
options nomfile; 
* A way of avoiding the poor editing capability of the Key binding process is ; 
* to write a macro -OF DSD COMMANDS - outside the DSD and call the macro from within the DSD; 
*these macros are stored in the macro catalog and are available at anytime during the session; 
* common macros can be called at startup * please execute the following code; 
        /* NO COMMENTS INSIDE MACRO DEFINITION! THE NAME IS G FOR "GO MACRO"; 
         this macro issues the command - go to a line number and examine all variables*/ 
%macro G(lineno); 
       go &lineno; 
       examine _all_; 
%mend G; 

       /* NO COMMENTS INSIDE MACRO DEFINITION!  THE NAME IS lp FOR "LooP Macro" 
         this macro sets a break at the current line - line must be first executable line in loop 
         LINENO IS THE LINE ON WHICH WE WANT THE BREAK, 
        UPVAR IS THE VARIABLE THAT CONTAINS THE UPPER LIMIT OF THE LOOP*/ 
%macro lp(lineno,Upvar); 
         B &lineno do; 
                  if (i=1 or i=&upvar ) then Ex _all_; 
                  else ex I &upvar; 
                end; 
%mend  lp; 

options nocenter; 
data non_profit (keep=name gender i YearToSearch rename=(i=AgeInFile)) ; 
  infile datalines missover firstobs=3; 
  length age_grp $ 5; 
  input @1 name  $char8. @10 gender $char1. @13 age1 2.0  
        @17 Home $char8. @25 Q1_hrs 3.      @30 Q2_hrs 3.
        @35 region 1.; 
  *PUT _NUMERIC_; 
  ThisYear =year(today()); 
  Firstyear=Thisyear-age1; 
  total= Q1_hrs + Q2_hrs; 
  pct_1= Q1_hrs  /total; 
  pct_2= Q1_hrs  /total; 
  do i=0 to age1; /*Output a line for every year: i=the age of the person in that year*/ 
    stopper="here"; 
    YearToSearch=firstyear+i; 
    *YOU CAN ALSO DIVIDE THE MAX BY AN INTEGER AND USE IN THE BREAK; 
     if i LE 12
         then do;  
              age_grp ="Child";  
              output non_profit; 
              end;                  
         else if i GT 12 and i LT 20
         then do; 
              age_grp ="Teen";  
              output non_profit; 
              end; 
        else if i GE 21
        then do; 
             age_grp ="Adult";  
             output non_profit; 
             end;         
  end;/*End of looping example do i=0 to age1;*/ 
/*Short example of finding errors with the debugger*/ 
*intentional mistake-compare what is in the PDV with what you expect to see; 
datalines; 
         1         2         3         4 
1234567890123456789012345678901234567890 
Sue      F  10  Florida 017  022  2 
Mike     M  12  Conn    027  042  1 
Erin     F  13 Ireland  021  012  5 
Ya-Ching F  20  China   017  024  5 
Ann      F  21  Mass    022  014  1 
Jeff     M  45 Calif    078  099  4 
Yuan     F  27  Nevada  026  046  4 
Suna     F  31  India   017  011  5 
Eric     M  45  Oregon  041  023  3 
; 
run; 

/****************************************************************** 
Section __: Cool if you can get to it 
*******************************************************************/ 
proc sort
  data=sashelp.class out=class; 
  by sex name; 
run; 

proc print  data=class; 
run;  

data drat /DEBUG; 
  set class; 
  by sex; 
  *if AGE LT 15; 
  WHERE AGE LT 15; 
  if first.sex=1
     then counter=0; 
  counter+1; 
  if last.sex then output; 
run; 

proc print data=drat; 
run; 

PROC SQL; 
  DROP TABLE DRAT; 
QUIT; 
**********************************************************************; 
**********************************************************************; 
**                                                                  **; 
**                  The End - Thanks for attending                  **; 
**                                                                  **; 
**********************************************************************; 
**********************************************************************; 


*****************************************************************************; 
**                                                                         **; 
**  PRACTICE ON THESE EXAMPLES                                             **; 
**                                                                         **; 
*****************************************************************************; 
*****************************************************************************; 
**                                                                         **; 
**  COLLECT HOW A MACRO EVALUATES AND STORES CLEAN CODE IN A TEXT FILE     **; 
**                                                                         **; 
*****************************************************************************; 
%MACRO series; 
  data &dsn; 
    total= %do i=6 %to 12; 
      &i %str(+) %end;  0 ; 
  run; 
  proc print data=&dsn; 
  run; 
  proc meansdata=&dsn;; run; 
%MEND series; 

/* the mprint mfile commands are for version 8 and up. 
If you have an earlier verison of SAS use options mprint reservedb1; 
filename mac_list 'c:\temp\lookSAS.txt'; 
      %the_macro_call; x fclose(c:\temp\ lookSAS.txt); 
*/ 
%let dsn=WhoWhoo; 
options mprint mfile;   *sends data to file; 
filename mprint "c:\temp\series_txt.txt"; 
%series;                *this runs the macro; 
  options nomprint;       *closes the file; 
  *****************************************************************************; 
  **                                                                         **; 
  **  Example of if _N_=1 then set statement                                 **; 
  **                                                                         **; 
  ** do this in steps, first look at data no_read                            **; 
  **     use the f4 key and binding of commands to keys                      **; 
  ** USE THIS, W/ break at look="look",                                      **; 
  **    Note THAT LAST IS VALUED BEFORE THE SET executes                     **; 
  **     SHOW THAT LAST IS NOT OUTPUT TO THE DATA SET & THEN APPLY THE KEEP  **; 
  **     SHOW AUTOMATIC RETAIN FOR VARIABLES FROM A SET STATEMENT            **; 
  *****************************************************************************; 
  *Example below is very short.  Run the code and issue ex _all_.  Note value of last; 
  *if you want header info in the output file you must copy it into another var see 531; 
  data no_read/debug; 
  *data no_read(keep=obs_perm) /debug; 
  *look="look"; *comment and uncomment this line - issue examine _all_ here; 
  if _N_ = 0
    then set left nobs=last; 
    obs_perm=last; 
  run; 

proc print data=no_read; 
title "No Last here, but You can get information from the file header on/when compiling"; 
run; 
title ""; 

data show_N_/debug; 
  if _n_=1 then set no_read; 
  set left; 
  wks_enr=enrolled/7; /* No business sense in this example*/ 
run; 

PROC PRINT
 ; title "Note that we have added a var to each line";
RUN; 

*****************************************************************************; 
**    NO RETAIN IF YOU USE AN INPUT STATEMENT                              **; 
**  This is from the SAS help file                                         **; 
**  This illustrates how there is NO retain for a input statement          **; 
**  the problem shows up when _n_=2                                        **; 
**                                                                         **; 
** USE THIS TO SHOW:                                                       **; 
**   BREAKS & DELETE BREAKS, EXAMINE ALL                                   **; 
**   SET A BREAK WHEN TOUR CHANGES AS AN ILLUSTRATION                      **; 
**   us the f4 keys and binding to keys                                    **; 
*****************************************************************************; 
/* first execution */ 
data tours (drop=type); 
   *RETAIN TOUR; 
   infile datalines missover firstobs=3; 
   input @1 type $ @; 
   if type='H' then do; 
      input @3 Tour $20.; 
      return; 
      end; 
   else if type='P' then do; 
      input @3 Name $10. Age 2. +1 Sex $1.; 
      output; 
      end; 
   datalines; 
         1         2         3         4         5 
12345678901234567890123456789012345678901234567890 
H Tour 101 
P Mary E    21 F 
P George S  45 M 
P Susan K    3 F 
H Tour 102 
P Adelle S  79 M 
P Walter P  55 M 
P Fran I    63 F 
; 
proc print data=tours; 
   title 'Tour List'; 
run; 

****************************************************************************; 
**                   MERGE EXAMPLE                                         **; 
** one to one, two to 1, one to two, three to two and two to three merge   **; 
**                                                                         **; 
** This is mostly a view of the SAS merge,and to see in=variables          **; 
** use breaks examine                                                      **; 
** break where r=0                                                         **; 
**   use f4 and keys                                                       **; 
*****************************************************************************; 
DATA  L_MEDS; 
  INFILE DATALINES MISSOVER firstobs=4; 
  /*KEEP THE UNREAD DATA IN FOR A WHILE - MAYBE WE'LL GET MORE VARIABLES*/ 
  input @1 name  $char8.  @10 LEFT_LINE 1.           @13 L_OB_CD  $CHAR4. 
        @19 gender 1.     @22 INF_con_frm $CHAR3.    @27 VNUM     1.
        @32 AM_PM $CHAR2. @34 EXER_TM     TIME8.     @44 LAB     $CHAR7.       ; 
  format EXER_TM time6.2; 
datalines; 
name   LEFT_LINE sex ICF VNUM AM/PM TIME   LAB 
         1         2         3         4         5 
12345678901234567890123456789012345678901234567890 
_1_1*1M  1  L1_1  1  YES  1    AM    2:20  ACME 
_2_2*1M  2  L2_1  1  YES  1    AM    2:20  ACME 
_2_2*1M  3  L2_2  1  YES  1    PM    2:40  GENERIC 
_3_1*2M  4  L3_1  2  YES  1    AM    2:10  GENERIC 
_4_2*3M  5  L4_1  2  YES  1    PM    2:19  ACE 
_4_2*3M  6  L4_2  1       1    AM    1:58  ACE 
_5_3*2M  7  L5_1  1       1    PM    2:02  ACME 
_5_3*2M  8  L5_2  1  YES  1    AM    2:50  ACME 
_5_3*2M  9  L5_3  1  YES  2    PM    2:02  ACME 
; 
RUN; 
PROC SORT DATA=L_MEDS; 
  BY NAME LEFT_LINE; 
RUN; 

DATA R_RUN_TIMES; /*SUBJECTS A HALF MILE AND RUN TWICE A DAY*/ 
 INFILE DATALINES MISSOVER FIRSTOBS=4; 
  input @1 name  $char8.        @11 RIGHT_LINE 1.        @14 R_OB_CD  $CHAR4.   @21 RAIN_YN 1.
        @26 RUN_ALONE  $CHAR3.  @33 SPLITS_YN  $CHAR3.   @37 ELAPS_TM   TIME10. @50 TRACK $CHAR12. 
        @64 WARMUP     $CHAR3. ; 
datalines; 
NAME   RIGHT_LINE RAIN  ALONE? SPLITS   ELAPS_TM  TRACK      WARMUP 
         1         2         3         4         5         6         7 
1234567890123456789012345678901234567890123456789012345678901234567890 
_1_1*1M   1  R1_1   1     NO     NO      2:20     mi/4 CINDER  YES 
_2_2*1M   2  R2_1   1     NO     YES     2:40     mi/4 TARTAN  YES 
_3_1*2M   3  R3_1   2     YES    NO      2:19     mi/4 TARTAN  NO 
_3_1*2M   4  R3_2   2     YES    NO      2:19     mi/4 TARTAN  NO 
_4_2*3M   5  R4_1   0     NO     NO      1:58     1/8 MI       NO 
_4_2*3M   6  R4_2   0     NO     NO      2:02     1/8 MI       NO 
_4_2*3M   7  R4_3   0     NO     NO      2:02     1/8 MI       NO 
_5_3*2M   8  R5_1   0     NO     NO      2:02     1/8 MI       YES 
_5_3*2M   9  R5_2   1     NO     YES     2:50     mi/4 TARTAN  YES 
; 
RUN; 
PROC SORT DATA=R_RUN_TIMES; 
  BY NAME RIGHT_LINE; 
RUN; 
*1 use a where r=0 to stop processing when we fail to read from r; *r always is 1; 
* use a watch on to jump to the next value of name - then step through; 
*mention that one ds has 8 obs and another has 9 then examine for _n_ ; 
OPTIONS LS=120; 
DATA  BOTH1 /DEBUG ; 
  MERGE L_MEDS      (IN=M ) END=ENDMED 
        R_RUN_TIMES (IN=R ) END=ENDRUN; 
  BY NAME; 
  PERM_M=m; 
  PERM_r=r; 
  P_ENDMED=ENDMED; 
  P_ENDRUN=ENDRUN; 
  DUMMY="XX"; 
  RUN; 
PROC PRINT
 DATA=BOTH1; 
  var name L_OB_CD R_OB_CD LEFT_LINE RIGHT_LINE  PERM_r    PERM_M  P_ENDMED   P_ENDRUN TRACK; 
RUN; 
*****************************************************************************; 
**                                                                         **; 
**                    SHOW ISSUES WITH LAG VARIABLES                       **; 
**                                                                         **; 
*****************************************************************************; 
data oops; 
infile datalines missover firstobs=3 ; 
input  @1 name $char3. @5 vnum 1. @8 pulse 2. @12 TST_CTRL $CHAR1.; 
datalines; 
         1         2 
12345678901234567890 
bob 0  72  T 
bob 1  72  T 
bob 2  74  T 
bob 3  75  T 
SUE 0  72  C 
SUE 1  72  C 
SUE 2  74  C 
SUE 3  75  C 
Lun 0  72  T 
Lun 1  72  T 
Lun 2  74  T 
Lun 3  75  T 
; 
run; 
proc sort data=oops; 
  by name vnum; 
run; 

proc print  data=oops; 
run; 

data oops2 /debug; 
  set oops; 
  by name vnum; 
  if first.name =0 then old=lag(pulse); 
run; 

proc print
 data=oops2; 
run; 
*****************************************************************************; 
**                                                                         **; 
**     SHOW END=EOF AND DIFFERENT FUNCTIONING OF WHERE VS IF               **; 
**                                                                         **; 
*****************************************************************************; 
data oops2; 
  infile datalines missover firstobs=3 ; 
  input  @1 name $char3. @5 vnum 1. @8 pulse 2. @12 TST_CTRL $CHAR1.; 
datalines; 
         1         2 
12345678901234567890 
bob 0  72  T 
bob 1  72  T 
bob 2  74  T 
bob 3  75  T 
SUE 0  72  C 
SUE 1  72  C 
SUE 2  74  C 
SUE 3  75  C 
Lun 0  72  T 
Lun 1  72  T 
Lun 2  74  T 
Lun 3  75  T 
; 
run; 

proc sort data=oops2; 
 by name vnum; 
run; 

proc print data=oops2; 
run; 
*USE A DATA STEP TO COUNT THE NUBER OF OBS; 
DATA _NULL_/debug; 
  SET OOPS2 END=EOF; 
  BY  name vnum; 
  stopper="here"; 
  *IF upcase(TST_CTRL)="C"; 
  where upcase(TST_CTRL)="C"; 
  counter+1; 
  if EOF=1 then 
   do; 
     put "this is the end and we had " counter "observations"; 
   end; 
run;
 
*****************************************************************************; 
**                                                                         **; 
**   SHOW attempts to use macro variables in DSD                     **; 
**                                                                         **; 
*****************************************************************************; 
OPTIONS MPRINT MLOGIC SYMBOLGEN; 
*create a couple of macro variables so we can toggle back and forth; 
*execute one or the other of the macro statements below; 
%LET TRACK=mi/4 TARTAN; 
%LET TRACK=1/8 MI; 
OPTIONS LS=120;*THIS RUNS AND uses the value of track to produce output; 
DATA BOTH2 /DEBUG; 
  MERGE L_MEDS      (IN=M ) END=ENDMED 
        R_RUN_TIMES (IN=R WHERE=( TRACK="&TRACK")) END=ENDRUN; 
  BY NAME; 
  MACRO_IS="&TRACK"; *JUST A WAY TO LOOK AT THE MACRO VARIABLE; 
  PERM_M=m; 
  PERM_r=r; 
  P_ENDMED=ENDMED; 
  P_ENDRUN=ENDRUN; 
  DUMMY="XX"; 
  TRACK_COUNT+1; 
  IF ENDRUN THEN PUT "SUBJECTS USED &TRACK TRACKS " TRACK_COUNT " TIMES"; 
  bo="gus"; 
RUN; 
*****************************************************************************; 
**                                                                         **; 
**  This shows an uncommon error with the IF                               **; 
**                                                                         **; 
*****************************************************************************; 
%LET TRACK=1/8 MI; 
OPTIONS LS=120;*THE IF STATEMENT DELETES THE OBS WHEN ENDRUN =1; 
DATA Odd_if /DEBUG; 
  Set  R_RUN_TIMES (IN=R ) END=ENDRUN; 
  MACRO_IS="&TRACK"; *JUST A WAY TO LOOK AT THE MACRO VARIABLE; 
  Symget_macro_is=symget("track"); 
  IF left(TRACK)= left(SYMGET('TRACK')); 
  PERM_r=r; 
  P_ENDRUN=ENDRUN; 
  DUMMY="A STOP POINT"; 
  TRACK_COUNT+1; 
  IF ENDRUN=1 THEN 
       DO; 
         PUT;PUT; 
         PUT "SUBJECTS USED &TRACK TRACKS " TRACK_COUNT " TIMES"; 
       END; 
  DUMMY2="A STOP POINT AFTER THE COMMAND THAT INTERESTS ME"; 
RUN; 
**********************************************************************; 
**********************************************************************; 
**                                                                  **; 
**                  Not in slides - see paper                       **; 
**                     IORC MERGE DSD                               **; 
**********************************************************************; 
**********************************************************************; 
data DAY_1; 
infile datalines missover; 
input @1  name $char4.  @10 Runner $char1.; 
datalines; 
Bob      Y 
russ     N 
Sue      N 
AJ       N 
Fred     Y 
Glenn    N 
KL       Y 
; /*<- 7 observations need updating*/ 
run;
 
Data UpDt; 
  infile datalines; 
  input @1 name $char4. @10 ShinSpl $char1. @15 T_elbow $char1. ; 
  label Shinspl=Shinsplints; 
datalines; 
Bob      S    N 
eric     S    N 
Sue      N    N 
Fred     S 
MarK     Y        <-NOTE MISSING VALUES
WalT     N 
KL       N    Y 
; 
run;
 
proc datasets
 lib=work; 
  modify UpDt; 
  index create name/unique; 
 quit; 
**no check of IORC ; 

data new1; 
  set DAY_1; 
  set UpDt key=name/unique; 
run;
 
/** you get errors ONLY for the folks in LEFt who do not match 
name=russ Runner=N ShinSpl=S T_elbow=N _ERROR_=1 _IORC_=1230015 _N_=2 
name=AJ Runner=N ShinSpl=N T_elbow=N _ERROR_=1 _IORC_=1230015 _N_=4 
name=Glen Runner=N ShinSpl=S T_elbow=  _ERROR_=1 _IORC_=1230015 _N_=6 
There are no error for mark and walt; 
***/ 
* do the normal stuff- if _iorc_ then delete; 
data new2; 
  set Day_1; 
  set UpDt key=name/unique; 
  if _iorc_  NE 0
  then do; 
       _error_=0; 
       delete; 
      end; 
run;

data new3; 
  set Day_1; 
  set UpDt key=name/unique; 
  array setmiss(*) $ ShinSpl--T_elbow; 
  if _iorc_ then 
    do; 
       _error_=0; 
       ** we know that the fileds from UPDT are on the RHS of the PBV; 
       ** watch out for mixed num & char ; 
       do i= 1 to dim(setmiss); 
         setmiss(i)=""; 
       end; 
    end; 
run;  

/***************  Jim Johnson page 4 ********************/
data one;
   a = 1;  b = 2;  
   output;
run;    
data two(drop=a keep=a) /debug;
   set one;
run;    


/***************  Jim Johnson page 7 ********************/
/*if statement deletes the "flag" but where does not*/
data a;
   a = 1; b = 2; c = 3; output;
   a = 2; b = 2; c = 3; output;
   a = 2; b = 2; c = 3; output;  /** duplicate **/
   a = 3; b = 2; c = 3; output;
   a = 3; b = 3; c = 3; output;
run;    

data b; /*failure - message not written*/
   set a end=last;
   if a = 2;
   if last then put "LAST OBS REACHED";    
run;    

data b;
   set a end=last;
   where a=2;
   if last then put "LAST OBS REACHED";
run;  


/***************  Jim Johnson page 10 ********************
SUMMARY OF SOME OF THE RULES OF RETAIN
Retaining a variable on an input data set has no effect.  Their values will be set by the input data set.
At the start of each iteration of the data step, non
-retained variables created in a data step are set to missing.
Variables created with a sum statement are automatically retained. **/
data one;
   a = 1; b = 1; c=5;
output;
   a = 1; b = .; c=5;output;
   a = 1; b = .; c=5;output;
run;    
data two;
   d = 0; e = 0; output;
   d = 1; e = 0; output;
   d = 2; e = 0; output;
run;    
data three;
   set one two;    
   retain a 5 b;
   if _n_ = 1 then f = 0;
   a + 1;      /** in retain stmt **/
   b = b + 1;  /** in retain stmt **/
   e + 1;      /** sum stmt, auto retain **/
   f = f + 1;  /** NOT retained **/
   g + 1;      /** sum stmt, auto retain **/
run; 

proc print data=three;
run; 

/*MISSING AS A DATA STEP KEYWORD - jim johnson page 12*/
/*this works but throws "NOTE: Variable missing is uninitialized."
- why does it work?*/
data one;
   text = 'abc'; output;
   text = 'def'; output;
   text = '';    output;
   text = 'ghi'; output;
run;    
data two;
   set one;
   if text = missing;
run;    
